Index: uspace/srv/hid/output/output.c
===================================================================
--- uspace/srv/hid/output/output.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/output.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,7 +27,7 @@
  */
 
+#include <errno.h>
 #include <stddef.h>
-#include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <macros.h>
 #include <as.h>
@@ -36,7 +36,4 @@
 #include <config.h>
 #include "port/ega.h"
-#include "port/kchar.h"
-#include "port/niagara.h"
-#include "port/ski.h"
 #include "port/chardev.h"
 #include "output.h"
@@ -222,4 +219,6 @@
 		dev->ops.cursor_update(dev, prev_col, prev_row, col, row,
 		    visible);
+		dev->ops.flush(dev);
+
 	}
 	
@@ -345,5 +344,8 @@
 			}
 		}
-	}
+		
+		dev->ops.flush(dev);
+	}
+	
 	
 	async_answer_0(iid, EOK);
@@ -383,6 +385,7 @@
 			}
 		}
-	}
-	
+		dev->ops.flush(dev);
+
+	}
 	async_answer_0(iid, EOK);
 }
@@ -479,10 +482,7 @@
 	if (!config_key_exists("console")) {
 		ega_init();
-		kchar_init();
-		niagara_init();
-		ski_init();
-	} else {
-		chardev_init();
-	}
+	}
+	
+	chardev_init();
 	
 	printf("%s: Accepting connections\n", NAME);
Index: uspace/srv/hid/output/output.h
===================================================================
--- uspace/srv/hid/output/output.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/output.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -52,4 +52,5 @@
 	    sysarg_t prev_row, sysarg_t col, sysarg_t row, bool visible);
 	void (* char_update)(struct outdev *dev, sysarg_t col, sysarg_t row);
+	void (* flush)(struct outdev *dev);
 } outdev_ops_t;
 
Index: uspace/srv/hid/output/port/chardev.c
===================================================================
--- uspace/srv/hid/output/port/chardev.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/port/chardev.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2016 Jakub Jermar
+ * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -30,23 +31,32 @@
  */
 
+#include <async.h>
+#include <config.h>
+#include <errno.h>
+#include <fibril_synch.h>
+#include <io/chardev.h>
+#include <loc.h>
 #include <stddef.h>
 #include <stdint.h>
-#include <char_dev_iface.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <async.h>
-#include <fibril_synch.h>
-#include <loc.h>
-#include <errno.h>
 #include <str.h>
-#include <config.h>
 #include "../ctl/serial.h"
 #include "../output.h"
 #include "chardev.h"
 
+enum {
+	chardev_buf_size = 4096
+};
+
 static char *console;
 
 static async_sess_t *sess;
+static chardev_t *chardev;
 static service_id_t serial_cat_id;
+static service_id_t console_cat_id;
+
+static uint8_t chardev_buf[chardev_buf_size];
+static size_t chardev_bused;
 
 static FIBRIL_MUTEX_INITIALIZE(discovery_lock);
@@ -54,13 +64,87 @@
 static FIBRIL_CONDVAR_INITIALIZE(discovery_cv);
 
+static void chardev_flush(void)
+{
+	size_t nwr;
+
+	if (chardev_bused == 0)
+		return;
+
+	chardev_write(chardev, chardev_buf, chardev_bused, &nwr);
+	/* XXX Handle error */
+
+	chardev_bused = 0;
+}
+
 static void chardev_putchar(wchar_t ch)
 {
-	uint8_t byte = (uint8_t) ch;
-	char_dev_write(sess, &byte, 1); 
+	if (chardev_bused == chardev_buf_size)
+		chardev_flush();
+	if (!ascii_check(ch))
+		ch = '?';
+	chardev_buf[chardev_bused++] = (uint8_t) ch;
 }
 
 static void chardev_control_puts(const char *str)
 {
-	char_dev_write(sess, (void *) str, str_size(str));
+	const char *p;
+
+	p = str;
+	while (*p != '\0')
+		chardev_putchar(*p++);
+}
+
+static bool find_output_dev(service_id_t *svcid)
+{
+	service_id_t *svc;
+	size_t svcs;
+	int rc;
+
+	rc = loc_category_get_svcs(serial_cat_id, &svc, &svcs);
+	if (rc != EOK) {
+		fibril_mutex_unlock(&discovery_lock);
+		printf("%s: Failed to get services\n", NAME);
+		return false;
+	}
+
+	for (size_t i = 0; i < svcs; i++) {
+		char *name;
+
+		rc = loc_service_get_name(svc[i], &name);
+		if (rc != EOK)
+			continue;
+
+		if (!str_cmp(console, name)) {
+			/*
+			 * This is the serial console service that the user
+			 * wanted to use.
+			 */
+			*svcid = svc[i];
+			free(svc);
+			return true;
+		}
+
+		free(name);
+	}
+
+	free(svc);
+
+	/* Look for any service in the 'console' category */
+
+	rc = loc_category_get_svcs(console_cat_id, &svc, &svcs);
+	if (rc != EOK) {
+		fibril_mutex_unlock(&discovery_lock);
+		printf("%s: Failed to get services\n", NAME);
+		return false;
+	}
+
+	if (svcs > 0) {
+		*svcid = svc[0];
+		free(svc);
+		return true;
+	}
+
+	free(svc);
+	return false;
 }
 
@@ -74,4 +158,6 @@
 {
 	int rc;
+	bool found;
+	service_id_t sid;
 
 	fibril_mutex_lock(&discovery_lock);
@@ -82,41 +168,19 @@
 	}
 
-	service_id_t *svc;
-	size_t svcs;
-	rc = loc_category_get_svcs(serial_cat_id, &svc, &svcs);
-	if (rc != EOK) {
-		fibril_mutex_unlock(&discovery_lock);
-		printf("%s: Failed to get services\n", NAME);
-		return;
-	}
-
-	service_id_t sid;
-	bool found = false;
-
-	for (size_t i = 0; i < svcs && !found; i++) {
-		char *name;
-		
-		rc = loc_service_get_name(svc[i], &name);
-		if (rc != EOK)
-			continue;
-
-		if (!str_cmp(console, name)) {
-			/*
-			 * This is the serial console service that the user
-			 * wanted to use.
-			 */
-			found = true;
-			sid = svc[i];
-		}
-			
-		free(name);
-	}
-
-	free(svc);
-
+	found = find_output_dev(&sid);
 	if (!found) {
 		fibril_mutex_unlock(&discovery_lock);
 		return;
 	}
+
+	printf("%s: Connecting service %zu\n", NAME, sid);
+	char *name;
+	rc = loc_service_get_name(sid, &name);
+	if (rc != EOK) {
+		fibril_mutex_unlock(&discovery_lock);
+		return;
+	}
+	printf("%s: Service name is %s\n", NAME, name);
+	free(name);
 
 	sess = loc_service_connect(sid, INTERFACE_DDF, IPC_FLAG_BLOCKING);
@@ -126,5 +190,13 @@
 		return;
 	}
-	serial_init(chardev_putchar, chardev_control_puts);
+
+	rc = chardev_open(sess, &chardev);
+	if (rc != EOK) {
+		fibril_mutex_unlock(&discovery_lock);
+		printf("%s: Failed opening character device\n", NAME);
+		return;
+	}
+
+	serial_init(chardev_putchar, chardev_control_puts, chardev_flush);
 
 	discovery_finished = true;
@@ -135,10 +207,19 @@
 int chardev_init(void)
 {
-	console = config_get_value("console");
-	if (!console) {
-		/*
-		 * The system is not configured to use serial console.
-		 */
+	if (!config_key_exists("console")) {
+		console = NULL;
+#ifdef MACHINE_ski
+		/* OK */
+#elif defined(UARCH_sparc64) && defined(PROCESSOR_sun4v)
+		/* OK */
+#elif defined(MACHINE_msim)
+		/* OK */
+#else
 		return EOK;
+#endif
+	} else {
+		console = config_get_value("console");
+		if (!console)
+			return EOK;
 	}
 
@@ -149,4 +230,10 @@
 	} 
 
+	rc = loc_category_get_id("console", &console_cat_id, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		printf("%s: Failed to get \"console\" category ID.\n", NAME);
+		return rc;
+	} 
+
 	rc = loc_register_cat_change_cb(check_for_dev);
 	if (rc != EOK) {
@@ -155,4 +242,6 @@
 		return rc;
 	}
+
+	check_for_dev();
 
 	fibril_mutex_lock(&discovery_lock);
Index: uspace/srv/hid/output/port/ega.c
===================================================================
--- uspace/srv/hid/output/port/ega.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/port/ega.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -169,4 +169,8 @@
 }
 
+static void ega_flush(outdev_t *dev)
+{
+}
+
 static outdev_ops_t ega_ops = {
 	.yield = ega_yield,
@@ -175,5 +179,6 @@
 	.get_caps = ega_get_caps,
 	.cursor_update = ega_cursor_update,
-	.char_update = ega_char_update
+	.char_update = ega_char_update,
+	.flush = ega_flush
 };
 
Index: uspace/srv/hid/output/port/kfb.c
===================================================================
--- uspace/srv/hid/output/port/kfb.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/port/kfb.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,5 +41,5 @@
 #include <sysinfo.h>
 #include <ddi.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <mem.h>
 #include <as.h>
Index: uspace/srv/hid/output/proto/vt100.c
===================================================================
--- uspace/srv/hid/output/proto/vt100.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/proto/vt100.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -32,7 +32,7 @@
 #include <inttypes.h>
 #include <errno.h>
+#include <stddef.h>
 #include <stdio.h>
-#include <stddef.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <io/color.h>
 #include <types/common.h>
@@ -139,5 +139,6 @@
 
 vt100_state_t *vt100_state_create(sysarg_t cols, sysarg_t rows,
-    vt100_putchar_t putchar_fn, vt100_control_puts_t control_puts_fn)
+    vt100_putchar_t putchar_fn, vt100_control_puts_t control_puts_fn,
+	vt100_flush_t flush_fn)
 {
 	vt100_state_t *state = malloc(sizeof(vt100_state_t));
@@ -147,4 +148,5 @@
 	state->putchar = putchar_fn;
 	state->control_puts = control_puts_fn;
+	state->flush = flush_fn;
 	
 	state->cols = cols;
@@ -228,4 +230,9 @@
 }
 
+void vt100_flush(vt100_state_t *state)
+{
+	state->flush();
+}
+
 /** @}
  */
Index: uspace/srv/hid/output/proto/vt100.h
===================================================================
--- uspace/srv/hid/output/proto/vt100.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/output/proto/vt100.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -37,4 +37,5 @@
 typedef void (* vt100_putchar_t)(wchar_t ch);
 typedef void (* vt100_control_puts_t)(const char *str);
+typedef void (* vt100_flush_t)(void);
 
 typedef struct {
@@ -48,8 +49,9 @@
 	vt100_putchar_t putchar;
 	vt100_control_puts_t control_puts;
+	vt100_flush_t flush;
 } vt100_state_t;
 
 extern vt100_state_t *vt100_state_create(sysarg_t, sysarg_t, vt100_putchar_t,
-    vt100_control_puts_t);
+    vt100_control_puts_t, vt100_flush_t);
 extern void vt100_state_destroy(vt100_state_t *);
 
@@ -62,4 +64,5 @@
 extern void vt100_cursor_visibility(vt100_state_t *, bool);
 extern void vt100_putchar(vt100_state_t *, wchar_t);
+extern void vt100_flush(vt100_state_t *);
 
 #endif
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/remcons/remcons.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -72,5 +72,5 @@
 static int remcons_open(con_srvs_t *, con_srv_t *);
 static int remcons_close(con_srv_t *);
-static int remcons_write(con_srv_t *, void *, size_t);
+static int remcons_write(con_srv_t *, void *, size_t, size_t *);
 static void remcons_sync(con_srv_t *);
 static void remcons_clear(con_srv_t *);
@@ -137,5 +137,5 @@
 }
 
-static int remcons_write(con_srv_t *srv, void *data, size_t size)
+static int remcons_write(con_srv_t *srv, void *data, size_t size, size_t *nwritten)
 {
 	telnet_user_t *user = srv_to_user(srv);
@@ -146,5 +146,6 @@
 		return rc;
 
-	return size;
+	*nwritten = size;
+	return EOK;
 }
 
Index: uspace/srv/hid/remcons/user.c
===================================================================
--- uspace/srv/hid/remcons/user.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/remcons/user.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,4 +34,5 @@
 #include <async.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <adt/prodcons.h>
 #include <errno.h>
@@ -40,5 +41,4 @@
 #include <io/keycode.h>
 #include <align.h>
-#include <malloc.h>
 #include <as.h>
 #include <fibril_synch.h>
Index: uspace/srv/hid/rfb/rfb.c
===================================================================
--- uspace/srv/hid/rfb/rfb.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/rfb/rfb.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -418,8 +418,8 @@
 }
 
-static ssize_t rfb_tile_encode_raw(rfb_t *rfb, cpixel_ctx_t *cpixel,
+static size_t rfb_tile_encode_raw(rfb_t *rfb, cpixel_ctx_t *cpixel,
     rfb_rectangle_t *tile, void *buf)
 {
-	ssize_t size = tile->width * tile->height * cpixel->size;
+	size_t size = tile->width * tile->height * cpixel->size;
 	if (buf == NULL)
 		return size;
@@ -435,6 +435,6 @@
 }
 
-static ssize_t rfb_tile_encode_solid(rfb_t *rfb, cpixel_ctx_t *cpixel,
-    rfb_rectangle_t *tile, void *buf)
+static size_t rfb_tile_encode_solid(rfb_t *rfb, cpixel_ctx_t *cpixel,
+    rfb_rectangle_t *tile, void *buf, size_t *size)
 {
 	/* Check if it is single color */
@@ -443,5 +443,5 @@
 		for (uint16_t x = tile->x; x < tile->x + tile->width; x++) {
 			if (pixelmap_get_pixel(&rfb->framebuffer, x, y) != the_color)
-				return -1;
+				return EINVAL;
 		}
 	}
@@ -450,5 +450,6 @@
 	if (buf)
 		cpixel_encode(rfb, cpixel, buf, the_color);
-	return cpixel->size;
+	*size = cpixel->size;
+	return EOK;
 }
 
@@ -474,6 +475,8 @@
 			
 			uint8_t tile_enctype = RFB_TILE_ENCODING_SOLID;
-			ssize_t tile_size = rfb_tile_encode_solid(rfb, &cpixel, &tile, buf);
-			if (tile_size < 0) {
+			size_t tile_size;
+			int rc = rfb_tile_encode_solid(rfb, &cpixel, &tile, buf,
+			    &tile_size);
+			if (rc != EOK) {
 				tile_size = rfb_tile_encode_raw(rfb, &cpixel, &tile, buf);
 				tile_enctype = RFB_TILE_ENCODING_RAW;
@@ -598,5 +601,6 @@
 	int rc = tcp_conn_send(conn, "RFB 003.008\n", 12);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server version %d", rc);
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server version: %s",
+		    str_error(rc));
 		return;
 	}
@@ -605,5 +609,6 @@
 	rc = recv_chars(conn, client_version, 12);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client version: %d", rc);
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client version: %s",
+		    str_error(rc));
 		return;
 	}
@@ -623,5 +628,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN,
-		    "Failed sending security handshake: %d", rc);
+		    "Failed sending security handshake: %s", str_error(rc));
 		return;
 	}
@@ -630,5 +635,6 @@
 	rc = recv_char(conn, &selected_sec_type);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving security type: %d", rc);
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving security type: %s",
+		    str_error(rc));
 		return;
 	}
@@ -641,5 +647,6 @@
 	rc = tcp_conn_send(conn, &security_result, sizeof(uint32_t));
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending security result: %d", rc);
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending security result: %s",
+		    str_error(rc));
 		return;
 	}
@@ -649,5 +656,6 @@
 	rc = recv_char(conn, &shared_flag);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client init: %d", rc);
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client init: %s",
+		    str_error(rc));
 		return;
 	}
@@ -672,5 +680,6 @@
 	rc = tcp_conn_send(conn, server_init, msg_length);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server init: %d", rc);
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server init: %s",
+		    str_error(rc));
 		return;
 	}
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -71,5 +71,5 @@
 static void s3c24xx_ts_connection(ipc_callid_t iid, ipc_call_t *icall,
     void *arg);
-static void s3c24xx_ts_irq_handler(ipc_callid_t iid, ipc_call_t *call, void *);
+static void s3c24xx_ts_irq_handler(ipc_call_t *call, void *);
 static void s3c24xx_ts_pen_down(s3c24xx_ts_t *ts);
 static void s3c24xx_ts_pen_up(s3c24xx_ts_t *ts);
@@ -137,5 +137,5 @@
 	    (void *) ts->paddr, inr);
 
-	async_irq_subscribe(inr, s3c24xx_ts_irq_handler, NULL, &ts_irq_code);
+	async_irq_subscribe(inr, s3c24xx_ts_irq_handler, NULL, &ts_irq_code, NULL);
 
 	s3c24xx_ts_wait_for_int_mode(ts, updn_down);
@@ -202,10 +202,9 @@
 
 /** Handle touchscreen interrupt */
-static void s3c24xx_ts_irq_handler(ipc_callid_t iid, ipc_call_t *call,
-    void *arg)
+static void s3c24xx_ts_irq_handler(ipc_call_t *call, void *arg)
 {
 	ts_updn_t updn;
 
-	(void) iid; (void) call;
+	(void) call;
 
 	/* Read up/down interrupt flags. */
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -27,7 +27,4 @@
  */
 
-/** @addtogroup driver_serial
- * @{
- */
 /**
  * @file
@@ -37,13 +34,13 @@
  */
 
+#include <async.h>
 #include <ddi.h>
+#include <errno.h>
+#include <inttypes.h>
+#include <io/chardev_srv.h>
 #include <loc.h>
-#include <ipc/char.h>
-#include <async.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <sysinfo.h>
-#include <errno.h>
-#include <inttypes.h>
 #include "s3c24xx_uart.h"
 
@@ -68,13 +65,21 @@
 
 static void s3c24xx_uart_connection(ipc_callid_t, ipc_call_t *, void *);
-static void s3c24xx_uart_irq_handler(ipc_callid_t, ipc_call_t *, void *);
+static void s3c24xx_uart_irq_handler(ipc_call_t *, void *);
 static int s3c24xx_uart_init(s3c24xx_uart_t *);
 static void s3c24xx_uart_sendb(s3c24xx_uart_t *, uint8_t);
 
+static int s3c24xx_uart_read(chardev_srv_t *, void *, size_t, size_t *);
+static int s3c24xx_uart_write(chardev_srv_t *, const void *, size_t, size_t *);
+
+static chardev_ops_t s3c24xx_uart_chardev_ops = {
+	.read = s3c24xx_uart_read,
+	.write = s3c24xx_uart_write
+};
+
 int main(int argc, char *argv[])
 {
 	printf("%s: S3C24xx on-chip UART driver\n", NAME);
 	
-	async_set_fallback_port_handler(s3c24xx_uart_connection, NULL);
+	async_set_fallback_port_handler(s3c24xx_uart_connection, uart);
 	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
@@ -111,45 +116,14 @@
     void *arg)
 {
-	/* Answer the IPC_M_CONNECT_ME_TO call. */
-	async_answer_0(iid, EOK);
-	
-	while (true) {
-		ipc_call_t call;
-		ipc_callid_t callid = async_get_call(&call);
-		sysarg_t method = IPC_GET_IMETHOD(call);
-		
-		if (!method) {
-			/* The other side has hung up. */
-			async_answer_0(callid, EOK);
-			return;
-		}
-		
-		async_sess_t *sess =
-		    async_callback_receive_start(EXCHANGE_SERIALIZE, &call);
-		if (sess != NULL) {
-			if (uart->client_sess == NULL) {
-				uart->client_sess = sess;
-				async_answer_0(callid, EOK);
-			} else
-				async_answer_0(callid, ELIMIT);
-		} else {
-			switch (method) {
-			case CHAR_WRITE_BYTE:
-				printf(NAME ": write %" PRIun " to device\n",
-				    IPC_GET_ARG1(call));
-				s3c24xx_uart_sendb(uart, (uint8_t) IPC_GET_ARG1(call));
-				async_answer_0(callid, EOK);
-				break;
-			default:
-				async_answer_0(callid, EINVAL);
-			}
-		}
-	}
-}
-
-static void s3c24xx_uart_irq_handler(ipc_callid_t iid, ipc_call_t *call,
-    void *arg)
-{
-	(void) iid;
+	s3c24xx_uart_t *uart = (s3c24xx_uart_t *) arg;
+
+	chardev_conn(iid, icall, &uart->cds);
+}
+
+
+static void s3c24xx_uart_irq_handler(ipc_call_t *call, void *arg)
+{
+	int rc;
+
 	(void) call;
 	(void) arg;
@@ -159,9 +133,12 @@
 		uint32_t status = pio_read_32(&uart->io->uerstat);
 
-		if (uart->client_sess != NULL) {
-			async_exch_t *exch = async_exchange_begin(uart->client_sess);
-			async_msg_1(exch, CHAR_NOTIF_BYTE, data);
-			async_exchange_end(exch);
-		}
+		fibril_mutex_lock(&uart->buf_lock);
+
+		rc = circ_buf_push(&uart->cbuf, &data);
+		if (rc != EOK)
+			printf(NAME ": Buffer overrun\n");
+
+		fibril_mutex_unlock(&uart->buf_lock);
+		fibril_condvar_broadcast(&uart->buf_cv);
 
 		if (status != 0)
@@ -176,4 +153,8 @@
 	sysarg_t inr;
 
+	circ_buf_init(&uart->cbuf, uart->buf, s3c24xx_uart_buf_size, 1);
+	fibril_mutex_initialize(&uart->buf_lock);
+	fibril_condvar_initialize(&uart->buf_cv);
+
 	if (sysinfo_get_value("s3c24xx_uart.address.physical",
 	    &uart->paddr) != EOK)
@@ -188,10 +169,9 @@
 
 	uart->io = vaddr;
-	uart->client_sess = NULL;
 
 	printf(NAME ": device at physical address %p, inr %" PRIun ".\n",
 	    (void *) uart->paddr, inr);
 
-	async_irq_subscribe(inr, s3c24xx_uart_irq_handler, NULL, &uart_irq_code);
+	async_irq_subscribe(inr, s3c24xx_uart_irq_handler, NULL, &uart_irq_code, NULL);
 
 	/* Enable FIFO, Tx trigger level: empty, Rx trigger level: 1 byte. */
@@ -203,4 +183,8 @@
 	    pio_read_32(&uart->io->ucon) & ~UCON_RX_INT_LEVEL);
 
+	chardev_srvs_init(&uart->cds);
+	uart->cds.ops = &s3c24xx_uart_chardev_ops;
+	uart->cds.sarg = uart;
+
 	return EOK;
 }
@@ -216,4 +200,46 @@
 }
 
+static int s3c24xx_uart_read(chardev_srv_t *srv, void *buf, size_t size,
+    size_t *nread)
+{
+	s3c24xx_uart_t *uart = (s3c24xx_uart_t *) srv->srvs->sarg;
+	size_t p;
+	uint8_t *bp = (uint8_t *) buf;
+	int rc;
+
+	fibril_mutex_lock(&uart->buf_lock);
+
+	while (circ_buf_nused(&uart->cbuf) == 0)
+		fibril_condvar_wait(&uart->buf_cv, &uart->buf_lock);
+
+	p = 0;
+	while (p < size) {
+		rc = circ_buf_pop(&uart->cbuf, &bp[p]);
+		if (rc != EOK)
+			break;
+		++p;
+	}
+
+	fibril_mutex_unlock(&uart->buf_lock);
+
+	*nread = p;
+	return EOK;
+}
+
+static int s3c24xx_uart_write(chardev_srv_t *srv, const void *data, size_t size,
+    size_t *nwr)
+{
+	s3c24xx_uart_t *uart = (s3c24xx_uart_t *) srv->srvs->sarg;
+	size_t i;
+	uint8_t *dp = (uint8_t *) data;
+
+	for (i = 0; i < size; i++)
+		s3c24xx_uart_sendb(uart, dp[i]); 
+
+	*nwr = size;
+	return EOK;
+}
+
+
 /** @}
  */
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.h
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,6 +38,9 @@
 #define S3C24XX_UART_H_
 
+#include <adt/circ_buf.h>
+#include <async.h>
+#include <fibril_synch.h>
+#include <io/chardev_srv.h>
 #include <stdint.h>
-#include <async.h>
 
 /** S3C24xx UART I/O */
@@ -76,4 +79,7 @@
 #define UFCON_FIFO_ENABLE		0x01
 
+enum {
+	s3c24xx_uart_buf_size = 64
+};
 
 /** S3C24xx UART instance */
@@ -85,9 +91,18 @@
 	s3c24xx_uart_io_t *io;
 
-	/** Callback session to the client */
-	async_sess_t *client_sess;
+	/** Character device service */
+	chardev_srvs_t cds;
 
 	/** Service ID */
 	service_id_t service_id;
+
+	/** Circular buffer */
+	circ_buf_t cbuf;
+	/** Buffer */
+	uint8_t buf[s3c24xx_uart_buf_size];
+	/** Buffer lock */
+	fibril_mutex_t buf_lock;
+	/** Signal newly added data in buffer */
+	fibril_condvar_t buf_cv;
 } s3c24xx_uart_t;
 
Index: uspace/srv/klog/klog.c
===================================================================
--- uspace/srv/klog/klog.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/klog/klog.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -44,5 +44,5 @@
 #include <io/klog.h>
 #include <sysinfo.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <fibril_synch.h>
 #include <adt/list.h>
@@ -100,13 +100,12 @@
 static void producer(void)
 {
-	int read = klog_read(buffer, BUFFER_SIZE);
-	
-	if (read < 0) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "klog_read failed, rc = %d",
-		    read);
+	size_t len = 0;
+	int rc = klog_read(buffer, BUFFER_SIZE, &len);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "klog_read failed, rc = %s",
+		    str_error_name(rc));
 		return;
 	}
 	
-	size_t len = read;
 	size_t offset = 0;
 	while (offset < len) {
@@ -189,11 +188,9 @@
  * Receives kernel klog notifications.
  *
- * @param callid IPC call ID
  * @param call   IPC call structure
  * @param arg    Local argument
  *
  */
-static void klog_notification_received(ipc_callid_t callid, ipc_call_t *call,
-    void *arg)
+static void klog_notification_received(ipc_call_t *call, void *arg)
 {
 	/*
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/loader/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -152,6 +152,7 @@
 	}
 
-	int file = vfs_receive_handle(true);
-	if (file < 0) {
+	int file;
+	rc = vfs_receive_handle(true, &file);
+	if (rc != EOK) {
 		async_answer_0(rid, EINVAL);
 		return;
@@ -254,6 +255,7 @@
 	}
 
-	int file = vfs_receive_handle(true);
-	if (file < 0) {
+	int file;
+	rc = vfs_receive_handle(true, &file);
+	if (rc != EOK) {
 		async_answer_0(rid, EINVAL);
 		return;
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/locsrv/locsrv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -47,4 +47,5 @@
 #include <stdlib.h>
 #include <str.h>
+#include <str_error.h>
 #include <ipc/loc.h>
 #include <assert.h>
@@ -1347,4 +1348,7 @@
 	categ_dir_add_cat(&cdir, cat);
 
+	cat = category_new("console");
+	categ_dir_add_cat(&cdir, cat);
+
 	cat = category_new("clock");
 	categ_dir_add_cat(&cdir, cat);
@@ -1526,11 +1530,15 @@
 	int rc = async_create_port(INTERFACE_LOC_SUPPLIER,
 	    loc_connection_supplier, NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("%s: Error while creating supplier port: %s\n", NAME, str_error(rc));
 		return rc;
+	}
 	
 	rc = async_create_port(INTERFACE_LOC_CONSUMER,
 	    loc_connection_consumer, NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("%s: Error while creating consumer port: %s\n", NAME, str_error(rc));
 		return rc;
+	}
 	
 	/* Set a handler of incomming connections */
@@ -1539,6 +1547,8 @@
 	/* Register location service at naming service */
 	rc = service_register(SERVICE_LOC);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("%s: Error while registering service: %s\n", NAME, str_error(rc));
 		return rc;
+	}
 	
 	printf("%s: Accepting connections\n", NAME);
Index: uspace/srv/logger/ctl.c
===================================================================
--- uspace/srv/logger/ctl.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/logger/ctl.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,6 +35,6 @@
  */
 
-#include <malloc.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <errno.h>
 #include <io/logctl.h>
@@ -87,7 +87,11 @@
 		}
 		case LOGGER_CONTROL_SET_ROOT: {
-			int fd = vfs_receive_handle(true);
-			vfs_root_set(fd);
-			async_answer_0(callid, fd >= 0 ? EOK : fd);
+			int fd;
+			int rc = vfs_receive_handle(true, &fd);
+			if (rc == EOK) {
+				rc = vfs_root_set(fd);
+				vfs_put(fd);
+			}
+			async_answer_0(callid, rc);
 			break;
 		}
Index: uspace/srv/logger/logs.c
===================================================================
--- uspace/srv/logger/logs.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/logger/logs.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -31,8 +31,8 @@
  */
 #include <assert.h>
-#include <malloc.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
 #include <str.h>
-#include <stdio.h>
-#include <errno.h>
 #include "logger.h"
 
Index: uspace/srv/logger/main.c
===================================================================
--- uspace/srv/logger/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/logger/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,7 +43,7 @@
 #include <async.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <errno.h>
 #include <str_error.h>
-#include <malloc.h>
 #include "logger.h"
 
@@ -72,11 +72,15 @@
 	int rc = async_create_port(INTERFACE_LOGGER_CONTROL,
 	    connection_handler_control, NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("%s: Error while creating control port: %s\n", NAME, str_error(rc));
 		return rc;
+	}
 	
 	rc = async_create_port(INTERFACE_LOGGER_WRITER,
 	    connection_handler_writer, NULL, &port);
-	if (rc != EOK)
+	if (rc != EOK) {
+		printf("%s: Error while creating writer port: %s\n", NAME, str_error(rc));
 		return rc;
+	}
 	
 	rc = service_register(SERVICE_LOGGER);
Index: uspace/srv/logger/writer.c
===================================================================
--- uspace/srv/logger/writer.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/logger/writer.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -43,8 +43,8 @@
 #include <ns.h>
 #include <async.h>
+#include <errno.h>
 #include <stdio.h>
-#include <errno.h>
+#include <stdlib.h>
 #include <str_error.h>
-#include <malloc.h>
 #include "logger.h"
 
@@ -80,5 +80,5 @@
 	}
 
-	KLOG_PRINTF(level, "[%s] %s: %s\n",
+	KLOG_PRINTF(level, "[%s] %s: %s",
 	    log->full_name, log_level_str(level),
 	    (const char *) message);
Index: uspace/srv/net/dhcp/dhcp.c
===================================================================
--- uspace/srv/net/dhcp/dhcp.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/dhcp/dhcp.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -39,4 +39,5 @@
 #include <byteorder.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <inet/addr.h>
@@ -370,5 +371,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
-		    "Error creating IP address %s (%d)", "dhcp4a", rc);
+		    "Error creating IP address %s: %s", "dhcp4a", str_error(rc));
 		return rc;
 	}
@@ -380,5 +381,5 @@
 		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Error creating "
-			    "default route %s (%d).", "dhcpdef", rc);
+			    "default route %s: %s.", "dhcpdef", str_error(rc));
 			return rc;
 		}
@@ -389,5 +390,5 @@
 		if (rc != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Error setting "
-			    "nameserver address (%d))", rc);
+			    "nameserver address: %s)", str_error(rc));
 			return rc;
 		}
Index: uspace/srv/net/dhcp/main.c
===================================================================
--- uspace/srv/net/dhcp/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/dhcp/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,4 +36,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <io/log.h>
 #include <inet/inetcfg.h>
@@ -69,5 +70,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
 		return EEXIST;
 	}
@@ -76,5 +77,5 @@
 	rc = loc_service_register(SERVICE_NAME_DHCP, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
 	}
Index: uspace/srv/net/dnsrsrv/dnsrsrv.c
===================================================================
--- uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,4 +36,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <io/log.h>
 #include <ipc/dnsr.h>
@@ -68,5 +69,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
 		transport_fini();
 		return EEXIST;
@@ -76,5 +77,5 @@
 	rc = loc_service_register(SERVICE_NAME_DNSR, &sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		transport_fini();
 		return EEXIST;
